# Publications

## Peer-reviewed Publications

> René Schöne, Sebastian Götz, Uwe Aßmann and Christoff Bürger.
> "Incremental Runtime-generation of Optimisation Problems using RAG-controlled Rewriting”.
> In: _MRT 2016: Proceedings of the 11th International Workshop on Models@run.time_.
> Volume 1742. CEUR Workshop Proceedings. CEUR-WS.org, October 2016, pp. 26–34.
> [Paper at CEUR-WS.org](http://ceur-ws.org/Vol-1742/MRT16_paper_5.pdf)

> Johannes Mey, René Schöne, Daniel Langner and Christoff Bürger.
> "Using Reference Attribute Grammar-Controlled Rewriting for Runtime Resource Management".
> In: _RES4ANT 2016: Proceedings of the 1st International Workshop on RESource Awareness and Application Auto-tuning in Adaptive and heterogeNeous compuTing_.
> Volume 1643. CEUR Workshop Proceedings. CEUR-WS.org, March 2016, pp. 13-17.
> [Paper at CEUR-WS.org](http://ceur-ws.org/Vol-1643/paper-03.pdf)

> Christoff Bürger.
> "Reference Attribute Grammar Controlled Graph Rewriting: Motivation and Overview".
> In: _Proceedings of the 2015 ACM SIGPLAN International Conference on Software Language Engineering_.
> ACM, October 2015, pages 89-100.
> [Paper at the ACM Digital Library](http://dl.acm.org/citation.cfm?id=2814257)

> Christoff Bürger, Johannes Mey, René Schöne, Sven Karol and Daniel Langner.
> "Using Reference Attribute Grammar-Controlled Rewriting for Energy Auto-Tuning”.
> In: _MRT 2015: Proceedings of the 10th International Workshop on Models@run.time_.
> Volume 1474. CEUR Workshop Proceedings. CEUR-WS.org, September 2015, pp. 31–40.
> [Paper at CEUR-WS.org](http://ceur-ws.org/Vol-1474/MRT15_paper_1.pdf)

> Christoff Bürger.
> "fUML Activity Diagrams with RAG-controlled Rewriting: A RACR Solution of The TTC 2015 Model Execution Case".
> In: _TTC 2015: Proceedings of the 8th Transformation Tool Contest_.
> Volume 1524. CEUR Workshop Proceedings. CEUR-WS.org, July 2015, pp. 27–36.
> [Original version at CEUR-WS.org](http://ceur-ws.org/Vol-1524/paper10.pdf), [up-to-date version](examples/ttc-2015-fuml-activity-diagrams/documentation/solution-description.pdf)

## Non-reviewed Publications

> Christoff Bürger. _RACR: A Scheme Library for Reference Attribute Grammar Controlled Rewriting_.
> Technical report, TUD-FI12-09. Lehrstuhl Softwaretechnologie, Technische Universität Dresden, December 2012.
> [Original version at Qucosa](http://nbn-resolving.de/urn:nbn:de:bsz:14-qucosa-104623), [up-to-date version](racr/documentation/title.md).

# Presentations

> Christoff Bürger. _Reference Attribute Grammar Controlled Graph Rewriting: Motivation and Overview_.
> Presentation at the 2015 ACM SIGPLAN International Conference on Software Language Engineering.
> Pittsburgh, USA, 27th October 2015.
> [Presentation](examples/sle-2015/documentation/presentation.pdf).

> Johannes Mey. _Using Reference Attribute Grammar-Controlled Rewriting for Energy Auto-Tuning_.
> Presentation at the 10th International Workshop on Models@run.time.
> Ottawa, Canada, 29th September 2015.
> [Presentation](https://github.com/christoff-buerger/reat/raw/master/documentation/presentation-mrt-2015.pdf).

> Christoff Bürger. _fUML Activity Diagrams with RAG-controlled Rewriting: A RACR Solution of The TTC 2015 Model Execution Case_.
> Presentation at the 8th Transformation Tool Contest.
> L'Aquila, Italy, 24th July 2015.
> [Presentation](examples/ttc-2015-fuml-activity-diagrams/documentation/solution-presentation.pdf), [poster](examples/ttc-2015-fuml-activity-diagrams/documentation/solution-poster-a0.pdf), [overall quality award](examples/ttc-2015-fuml-activity-diagrams/documentation/solution-award.pdf).

> Марта Тасић. _Benchmarking Incremental Dynamic Attribute Evaluation - RACR/JastAdd Performance Case Study in the Domain of Invasive Software Composition_.
> Presentation at Lehrstuhl Softwaretechnologie, Technische Universität Dresden.
> Dresden, Germany, 1st July 2014.
> [Presentation](https://github.com/christoff-buerger/racr-boneyard/raw/master/invasive-composition/original-case-study-by-Марта-Тасић/Benchmarking-Incremental-Dynamic-Attribute-Evaluation-RACR-JastAdd-Performance-Case-Study-in-the-Domain-of-Invasive-Software-Composition.pdf), [original sources on GitHub](https://github.com/christoff-buerger/racr-boneyard/tree/master/invasive-composition/original-case-study-by-Марта-Тасић), [up-to-date sources on GitHub](https://github.com/christoff-buerger/racr-boneyard/tree/master/invasive-composition/refactored-case-study-by-Christoff-Bürger).
