_[>> Title <<](title.md) [>> Synopsis <<](synopsis.md) [>> Contents <<](contents.md) [>> API Index <<](api-index.md)_
___

# _RACR_ Synopsis

_RACR_ is a _Scheme_ Library for Reference Attribute Grammar Controlled Rewriting. It supports incremental attribute evaluation in the presence of arbitrary abstract syntax tree rewrites. It provides a set of functions that can be used to specify abstract syntax tree schemes and their attribution and construct respective trees, query their attributes and node information and annotate and rewrite them. Thereby, both, reference attribute grammars and rewriting, are seamlessly integrated, such that rewrites can reuse attributes and attribute values change depending on performed rewrites -– a technique we call Reference Attribute Grammar Controlled Rewriting. To reevaluate attributes influenced by abstract syntax tree rewrites, a demand-driven, incremental evaluation strategy, which incorporates the actual execution paths selected at runtime for control-flows within attribute equations, is used. To realise this strategy, a dynamic attribute dependency graph is constructed throughout attribute evaluation –- a technique we call Dynamic Attribute Dependency Analyses.

Besides synthesised and inherited attributes, _RACR_ supports reference, parameterised and circular attributes, attribute broadcasting and abstract syntax tree and attribute inheritance. _RACR_ also supports graph pattern matching to ease the specification of complex rewires, whereas patterns can reuse attributes for rewrite conditions such that complex analyses that control rewriting can be specified. Similarly to attribute values, tests for pattern matches are incrementally evaluated and automatically cached. Further, linear pattern matching complexity is guaranteed if involved attributes are already evaluated. Thus, the main drawback of graph rewriting, the matching problem of polynomial complexity for bounded pattern sizes, is attenuated.

Since _RACR_ is an ordinary _Scheme_ library, its functions can arbitrarily interact with _Scheme_ programs and vice versa. To implement attribute equations and rewrites, users reuse or develop ordinary _Scheme_ functions with arbitrary control-flows, function calls, macro expansions and continuations. The required bookkeeping for incremental attribute evaluation is transparently and automatically performed by _RACR_ and cannot be bypassed or disturbed.

This reference manual documents [_RACR's_ features](introduction.md#racr-features), instantiation and usage. It summarises and exemplifies [_RACR's_ application programming interface](api-index.md). The Implementation of reference attribute grammar controlled rewriting or dynamic attribute dependency analyses is not discussed. Readers should be comfortable with _Scheme_; This reference manual is not a _Scheme_ introduction!
