**Software:** _RACR_ (Reference Attribute Grammar Controlled Rewriting)

**Public Git Repository:** https://github.com/christoff-buerger/racr

**Author:** Christoff Bürger (`christoff.buerger@gmail.com`)

# Documentation

A short [synopsis](racr/documentation/synopsis.md) gives an overview what _RACR_ is all about; also consider its [feature list](racr/documentation/introduction.md#racr-features). For documentation consult _RACR's_ [reference manual](racr/documentation/title.md). Besides _RACR's_ application programming interface, it provides detailed [installation instructions](racr/documentation/requirements-and-installation.md). To get started, [documented examples](examples/examples-overview.md) are in the `./examples` directory.

Besides _Scheme_, _RACR_ can also be used as _C#_-library. The [_RACR-NET_ manual](racr-net/documentation/title.md) describes its application in _.NET_ using _C#_ (a well understanding of the basic functionalities described in the reference manual is assumed).

There also exists a list of [scientific publications and presentations](publications.md) regarding RAG-controlled rewriting, _RACR_ and its applications.

# License

This program and the accompanying materials are made available under the terms of the MIT license (X11 license) which accompanies this distribution (`./license.txt`).
